import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;

import javax.swing.JApplet;

public class MyApplet extends JApplet
{
	public MyApplet()
	{
		r = new Random();
		filterSize = 3;
		numBlackWhite = 2000;
		fileName = "test1.gif";
	}

	public void init()
	{
		setBackground(Color.white);

		image = getImage(getCodeBase(), fileName);

		width = image.getWidth(new JLabel(new ImageIcon(image)));
		height = image.getHeight(new JLabel(new ImageIcon(image)));

		imagePanel = new JPanel();
		controlPanel = new JPanel();
		
		// Moved these lines from paint()
		getContentPane().add(imagePanel, BorderLayout.CENTER);
		getContentPane().add(controlPanel, BorderLayout.SOUTH);

		imageLabel = new JLabel(new ImageIcon(image));
		noisyLabel = new JLabel(new ImageIcon(image));
		filteredLabel = new JLabel(new ImageIcon(image));
		imagePanel.add(imageLabel);
		imagePanel.add(noisyLabel);
		imagePanel.add(filteredLabel);

		width = image.getWidth(imageLabel);
		height = image.getHeight(imageLabel);

		final JComboBox filter = new JComboBox();
		final JComboBox noise = new JComboBox();
		final JComboBox imageList = new JComboBox();
		
		ActionListener al = new ActionListener()
		{
			public void actionPerformed(ActionEvent event)
			{
				if(filter.getSelectedItem().equals("3x3")) filterSize = 3;
				else if(filter.getSelectedItem().equals("5x5")) filterSize = 5;
				else if(filter.getSelectedItem().equals("7x7")) filterSize = 7;
				else if(filter.getSelectedItem().equals("9x9")) filterSize = 9;
				else if(filter.getSelectedItem().equals("11x11")) filterSize = 11;
				else if(filter.getSelectedItem().equals("13x13")) filterSize = 13;
				else if(filter.getSelectedItem().equals("15x15")) filterSize = 15;

				long size = width * height;
				if(noise.getSelectedItem().equals("1%")) numBlackWhite = Math.round(size * 0.01);
				else if(noise.getSelectedItem().equals("5%")) numBlackWhite = Math.round((width*height) * 0.05);
				else if(noise.getSelectedItem().equals("10%")) numBlackWhite = Math.round((width*height) * 0.1);
				else if(noise.getSelectedItem().equals("15%")) numBlackWhite = Math.round((width*height) * 0.15);
				else if(noise.getSelectedItem().equals("20%")) numBlackWhite = Math.round((width*height) * 0.2);
				else if(noise.getSelectedItem().equals("25%")) numBlackWhite = Math.round((width*height) * 0.25);
				else if(noise.getSelectedItem().equals("50%")) numBlackWhite = Math.round((width*height) * 0.5);

				if(imageList.getSelectedItem().equals("test1.gif")) fileName = "test1.gif";
				else if(imageList.getSelectedItem().equals("test2.gif")) fileName = "test2.gif";
				else if(imageList.getSelectedItem().equals("test3.gif")) fileName = "test3.gif";
				else if(imageList.getSelectedItem().equals("test4.gif")) fileName = "test4.gif";
				else if(imageList.getSelectedItem().equals("test5.gif")) fileName = "test5.gif";
				else if(imageList.getSelectedItem().equals("test6.gif")) fileName = "test6.gif";
				else if(imageList.getSelectedItem().equals("test7.gif")) fileName = "test7.gif";

				updateImage();
				updateNoise();
				updateFilter();

				// This fixes the imaging problem
				setEnabled(false);
				validate();
				setEnabled(true);
				repaint();
			}
		};
		
		filter.addItem("3x3");
		filter.addItem("5x5");
		filter.addItem("7x7");
		filter.addItem("9x9");
		filter.addItem("11x11");
		filter.addItem("13x13");
		filter.addItem("15x15");
		filter.setSelectedIndex(0);
		filter.addActionListener(al);
		
		noise.addItem("1%");
		noise.addItem("5%");
		noise.addItem("10%");
		noise.addItem("15%");
		noise.addItem("20%");
		noise.addItem("25%");
		noise.addItem("50%");
		noise.setSelectedIndex(2);
		noise.addActionListener(al);

		imageList.addItem("test1.gif");
		imageList.addItem("test2.gif");
		imageList.addItem("test3.gif");
		imageList.addItem("test4.gif");
		imageList.addItem("test5.gif");
		imageList.addItem("test6.gif");
		imageList.addItem("test7.gif");
		imageList.setSelectedIndex(0);
		imageList.addActionListener(al);

		controlPanel.add(imageList);
		controlPanel.add(noise);
		controlPanel.add(filter);
		
		filter.setSelectedIndex(0);
	}

	public void start()
	{
		setEnabled(false);
		validate();
		setEnabled(true);
		repaint();
	}

	// Gets the pixel data into the pixels array
	public void updateImage()
	{
		imagePanel.remove(imageLabel);
		image = getImage(getCodeBase(), fileName);

		imageLabel = new JLabel(new ImageIcon(image));
		width = image.getWidth(imageLabel);
		height = image.getHeight(imageLabel);

		pixels = new int[width * height];
		try {
			PixelGrabber pg = new PixelGrabber(image, 0, 0, width, height, pixels, 0, width);
			pg.grabPixels();
		} catch(Exception e) { }
		imagePanel.add(imageLabel);
	}

	// Uses filterSize to median filter the noisy image
	public void updateFilter()
	{
		imagePanel.remove(filteredLabel);
		filter();
		filteredImage = createImage(new MemoryImageSource(width, height, filtered, 0, width));
		filteredLabel = new JLabel(new ImageIcon(filteredImage));
		imagePanel.add(filteredLabel);

		validate();
	}

	// Uses numBlackWhite to add S&P noise to the image
	public void updateNoise()
	{
		imagePanel.remove(noisyLabel);
		for(int i = 0; i < numBlackWhite; i++)
		{
			if(r.nextInt(2) == 0) makeWhite(r.nextInt(height), r.nextInt(width));
			else makeBlack(r.nextInt(height), r.nextInt(width));
		}

		noisyImage = createImage(new MemoryImageSource(width, height, pixels, 0, width));
		noisyLabel = new JLabel(new ImageIcon(noisyImage));
		imagePanel.add(noisyLabel);		
	}
/*
	public void paint(Graphics g)
	{
		super.paint(g);

	}
*/
	public void makeWhite(int x, int y)
	{
		int white = 0xffffffff;
		pixels[x * width + y] = white;
	}

	public void makeBlack(int x, int y)
	{
		int white = 0xff000000;
		pixels[x * width + y] = white;
	}

/*
	public void handlesinglepixel(int pixel) {
		int alpha = (pixel >> 24) & 0xff;
		int red   = (pixel >> 16) & 0xff;
		int green = (pixel >>  8) & 0xff;
		int blue  = (pixel      ) & 0xff;
		// System.err.println("RED:" + red + " GREEN:" + green + " BLUE:" + blue);
	 }
*/

	Random r;
	int width, height, filterSize, maxW, maxH;
	int[] pixels;
	int[] filtered;
	Image image, noisyImage, filteredImage;
	JPanel imagePanel, controlPanel;
	long numBlackWhite;
	JLabel filteredLabel, noisyLabel, imageLabel;
	String fileName;

	private void filter()
    {
        int min = (filterSize - 1) / 2; //Determine new border width created by pixels that cannot be filtered
        maxW = width - min; //Determine the width of the new image
        maxH = height - min; //Determine the height of the new image
        int numPoints = filterSize * filterSize; //determine size of the template
        filtered = new int[width * height]; //create array to store new pixel values
		//set all pixels to be filtered to unfiltered pixels logically ANDed with white value (0xff)
        for(int y = 0; y < height; y++)
        {
            for(int x = 0; x < width; x++)
            {
                int index = y * width + x;
                filtered[index] = pixels[index] & 0xff;
            }

        }
		
        for(int y = min; y < maxH; y++)
        {
            for(int x = min; x < maxW; x++)
            {
                int tempPixel = median(x, y, min, numPoints); //Calculate median value for new pixel
                int newPixel = tempPixel << 16 | tempPixel << 8 | tempPixel;
                filtered[y * width + x] = 0xff000000 | newPixel;
            }

        }

    }

    private int median(int xLoc, int yLoc, int halfSize, int numPoints)
    {
        //Set maximum and minimum values for pixels to use in the template
		int xMin = xLoc - halfSize;
        int xMax = xLoc + halfSize;
        int yMin = yLoc - halfSize;
        int yMax = yLoc + halfSize;
		
        int points[] = new int[numPoints]; //Define an array to store pixel values
        int count = 0;
        int thisMin = 0x7fffffff;  //Set minimum value in array
        int medPoint = (numPoints + 1) / 2; //detemine middle of the array so median can be extracted
        //Allocate current pixels value of the template into the array
		for(int y = yMin; y <= yMax; y++)
        {
            for(int x = xMin; x <= xMax; x++)
                points[count++] = pixels[y * width + x] & 0xff; //logically AND value with white

        }
		int tmppoints[] = new int[numPoints];
		//System.out.println("Old median:"+points[medPoint]);
		mergeSort(points,tmppoints,0,numPoints-1);
		//System.out.println("New median:"+points[medPoint]);
		return points[medPoint];
/*label0:
        for(int i = 0; i < medPoint; i++)
        {
            thisMin = 0x7fffffff;
            int j;
            for(j = 0; j < numPoints; j++)
                if(points[j] < thisMin)
                    thisMin = points[j]; //Determine lowest value of the template array.

            j = 0;
            do
            {
                if(j >= numPoints)
                    continue label0;
                if(points[j] == thisMin)
                {
                    points[j] = 0x7fffffff;
                    continue label0;
                }
                j++;
            } while(true);
        }*/
    }

		private static void mergeSort(int[] pixels, int[] tmppixels, int left, int right){
		if (left<right){
			int centre = (left+right)/2;
		//	System.out.println("left: "+left+", right:"+right);
			mergeSort(pixels, tmppixels, left, centre);
			mergeSort(pixels, tmppixels, centre+1,right);
			merge(pixels, tmppixels, left, centre+1, right);
		}
	}

	private static void merge(int[] pixels, int[] tmppixels, int leftPos, int rightPos, int rightEnd){
		int leftEnd = rightPos-1;
		int tmpPos = leftPos;
		int numElements = rightEnd-leftPos+1;
	//	System.out.println("Leftpos: "+leftPos+", rightPos: "+rightPos);
		while (leftPos<=leftEnd && rightPos<=rightEnd){
			if (pixels[leftPos]>pixels[rightPos]){
				tmppixels[tmpPos++] = pixels[leftPos++];
			}
			else{
				tmppixels[tmpPos++] = pixels[rightPos++];
			}
		}
		while (leftPos<=leftEnd){
			tmppixels[tmpPos++]=pixels[leftPos++];
		}
		while (rightPos<=rightEnd){
			tmppixels[tmpPos++]=pixels[rightPos++];
		}
		for (int i=0; i<numElements; i++, rightEnd--){
			pixels[rightEnd] = tmppixels[rightEnd];
		}
	}
}
