// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MedianFilter.java

import java.awt.image.*;

// size is size of the filter, eg 3->3x3, 5->5x5
// MedianFilter medianFilter = new MedianFilter(size);
// filteredImage = createImage(new FilteredImageSource(image.getSource(), medianFilter));

public class MedianFilter extends ImageFilter
{

    public MedianFilter(int size)
    {
        filterSize = size;
    }

    public void imageComplete(int status)
    {
        filter();
        super.consumer.setPixels(0, 0, width, height, null, filtered, 0, width);
        super.consumer.imageComplete(status);
    }

    private void filter()
    {
        int min = (filterSize - 1) / 2;
        int maxW = width - min;
        int maxH = height - min;
        int numPoints = filterSize * filterSize;
        filtered = new int[width * height];
        for(int y = 0; y < height; y++)
        {
            for(int x = 0; x < width; x++)
            {
                int index = y * width + x;
                filtered[index] = data[index] & 0xff;
            }

        }

        for(int y = min; y < maxH; y++)
        {
            for(int x = min; x < maxW; x++)
            {
                int tempPixel = median(x, y, min, numPoints);
                int newPixel = tempPixel << 16 | tempPixel << 8 | tempPixel;
                filtered[y * width + x] = 0xff000000 | newPixel;
            }

        }

    }

    private int median(int xLoc, int yLoc, int halfSize, int numPoints)
    {
        int xMin = xLoc - halfSize;
        int xMax = xLoc + halfSize;
        int yMin = yLoc - halfSize;
        int yMax = yLoc + halfSize;
        int points[] = new int[numPoints];
        int count = 0;
        int thisMin = 0x7fffffff;
        int medPoint = (numPoints + 1) / 2;
        for(int y = yMin; y <= yMax; y++)
        {
            for(int x = xMin; x <= xMax; x++)
                points[count++] = data[y * width + x] & 0xff;

        }

label0:
        for(int i = 0; i < medPoint; i++)
        {
            thisMin = 0x7fffffff;
            int j;
            for(j = 0; j < numPoints; j++)
                if(points[j] < thisMin)
                    thisMin = points[j];

            j = 0;
            do
            {
                if(j >= numPoints)
                    continue label0;
                if(points[j] == thisMin)
                {
                    points[j] = 0x7fffffff;
                    continue label0;
                }
                j++;
            } while(true);
        }

        return thisMin;
    }

    public void setColorModel(ColorModel col)
    {
        super.consumer.setColorModel(ColorModel.getRGBdefault());
        cm = col;
    }

    public void setDimensions(int w, int h)
    {
        data = new int[w * h];
        for(int i = 0; i < w * h; i++)
            data[i] = 0xff000000;

        width = w;
        height = h;
        super.consumer.setDimensions(w, h);
    }

    public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels[], int off, 
            int scansize)
    {
        int srcoff = off;
        int dstoff = y * width + x;
        for(int yc = 0; yc < h; yc++)
        {
            for(int xc = 0; xc < w; xc++)
                data[dstoff++] = model.getRGB(pixels[srcoff++] & 0xff);

            srcoff += scansize - w;
            dstoff += width - w;
        }

    }

    int width;
    int height;
    int filterSize;
    int filtered[];
    int data[];
    ColorModel cm;
}
