// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MedianFilter.java

import java.awt.image.*;

// size is size of the filter, eg 3->3x3, 5->5x5
// MedianFilter medianFilter = new MedianFilter(size);
// filteredImage = createImage(new FilteredImageSource(image.getSource(), medianFilter));

public class MedianFilter extends ImageFilter
{

    public MedianFilter(int size)
    {
        filterSize = size;
    }

    public void imageComplete(int status)
    {
        filter();
	//	System.out.println("Filter executed");
        super.consumer.setPixels(0, 0, width, height, new DirectColorModel(16, 0xf000, 0x0f00, 0x00f0, 0x000f), filtered, 0, width);
    //   System.out.println("pixels set");
	    super.consumer.imageComplete(status);
	//	System.out.println("image complete");
    }

    private void filter()
    {
        int min = (filterSize - 1) / 2; //Determine new border width created by pixels that cannot be filtered
        int maxW = width - min; //Determine the width of the new image
        int maxH = height - min; //Determine the height of the new image
        int numPoints = filterSize * filterSize; //determine size of the template
        filtered = new int[width * height]; //create array to store new pixel values
		//set all pixels to be filtered to unfiltered pixels logically ANDed with white value (0xff)
        for(int y = 0; y < height; y++)
        {
            for(int x = 0; x < width; x++)
            {
                int index = y * width + x;
                filtered[index] = data[index] & 0xff;
            }

        }
		
        for(int y = min; y < maxH; y++)
        {
            for(int x = min; x < maxW; x++)
            {
                int tempPixel = median(x, y, min, numPoints); //Calculate median value for new pixel
                int newPixel = tempPixel << 16 | tempPixel << 8 | tempPixel;
                filtered[y * width + x] = 0xff000000 | newPixel;
            }

        }

    }

    private int median(int xLoc, int yLoc, int halfSize, int numPoints)
    {
        //Set maximum and minimum values for pixels to use in the template
		int xMin = xLoc - halfSize;
        int xMax = xLoc + halfSize;
        int yMin = yLoc - halfSize;
        int yMax = yLoc + halfSize;
		
        int points[] = new int[numPoints]; //Define an array to store pixel values
        int count = 0;
        int thisMin = 0x7fffffff;  //Set minimum value in array
        int medPoint = (numPoints + 1) / 2; //detemine middle of the array so median can be extracted
        //Allocate current pixels value of the template into the array
		for(int y = yMin; y <= yMax; y++)
        {
            for(int x = xMin; x <= xMax; x++)
                points[count++] = data[y * width + x] & 0xff; //logically AND value with white

        }
		int tmppoints[] = new int[numPoints];
		//System.out.println("Old median:"+points[medPoint]);
		mergeSort(points,tmppoints,0,numPoints-1);
		//System.out.println("New median:"+points[medPoint]);
		return points[medPoint];
/*label0:
        for(int i = 0; i < medPoint; i++)
        {
            thisMin = 0x7fffffff;
            int j;
            for(j = 0; j < numPoints; j++)
                if(points[j] < thisMin)
                    thisMin = points[j]; //Determine lowest value of the template array.

            j = 0;
            do
            {
                if(j >= numPoints)
                    continue label0;
                if(points[j] == thisMin)
                {
                    points[j] = 0x7fffffff;
                    continue label0;
                }
                j++;
            } while(true);
        }*/
    }

    public void setColorModel(ColorModel col)
    {
        super.consumer.setColorModel(ColorModel.getRGBdefault());
        cm = col;
    }

    public void setDimensions(int w, int h)
    {
        data = new int[w * h];
        for(int i = 0; i < w * h; i++)
            data[i] = 0xff000000;

        width = w;
        height = h;
        super.consumer.setDimensions(w, h);
    }

    public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels2[], int off, 
            int scansize)
    {
        int srcoff = off;
        int dstoff = y * width + x;
        for(int yc = 0; yc < h; yc++)
        {
            for(int xc = 0; xc < w; xc++)
                data[dstoff++] = model.getRGB(pixels2[srcoff++] & 0xff);

            srcoff += scansize - w;
            dstoff += width - w;
        }

    }
	private static void mergeSort(int[] pixels, int[] tmppixels, int left, int right){
		if (left<right){
			int centre = (left+right)/2;
		//	System.out.println("left: "+left+", right:"+right);
			mergeSort(pixels, tmppixels, left, centre);
			mergeSort(pixels, tmppixels, centre+1,right);
			merge(pixels, tmppixels, left, centre+1, right);
		}
	}

	private static void merge(int[] pixels, int[] tmppixels, int leftPos, int rightPos, int rightEnd){
		int leftEnd = rightPos-1;
		int tmpPos = leftPos;
		int numElements = rightEnd-leftPos+1;
	//	System.out.println("Leftpos: "+leftPos+", rightPos: "+rightPos);
		while (leftPos<=leftEnd && rightPos<=rightEnd){
			if (pixels[leftPos]>pixels[rightPos]){
				tmppixels[tmpPos++] = pixels[leftPos++];
			}
			else{
				tmppixels[tmpPos++] = pixels[rightPos++];
			}
		}
		while (leftPos<=leftEnd){
			tmppixels[tmpPos++]=pixels[leftPos++];
		}
		while (rightPos<=rightEnd){
			tmppixels[tmpPos++]=pixels[rightPos++];
		}
		for (int i=0; i<numElements; i++, rightEnd--){
			pixels[rightEnd] = tmppixels[rightEnd];
		}
	}
    int width;
    int height;
    int filterSize;
    int filtered[];
    int data[];
    ColorModel cm;
}


